/*******************************************************************************
 *
 * Filename: main.c
 *
 * Basic entry points for top-level functions
 *
 * Revision information:
 *
 * 20AUG2004	kb_admin	initial creation
 * 17APR2005	kb_admin	1.3.0:
 *				  added version tracking and several packages
 * 29APR2005	kb_admin	1.3.1:
 *				  added ROM-RAM copy operation
 *
 * BEGIN_KBDD_BLOCK
 * No warranty, expressed or implied, is included with this software.  It is
 * provided "AS IS" and no warranty of any kind including statutory or aspects
 * relating to merchantability or fitness for any purpose is provided.  All
 * intellectual property rights of others is maintained with the respective
 * owners.  This software is not copyrighted and is intended for reference
 * only.
 * END_BLOCK
 ******************************************************************************/

#include "at91rm9200_lowlevel.h"
#include "debug_io.h"
#include "eeprom.h"
#include "emac.h"
#include "flash.h"
#include "irda.h"
#include "lcd.h"
#include "led.h"
#include "lib.h"
#include "prompt.h"
#include "processor.h"
#include "spi_flash.h"
#include "twsi.h"
#include "uhp.h"
#include "xmodem_cmd.h"

/*
 * .KB_C_FN_DEFINITION_START
 * int main(void)
 *  This global function serves as the entry point to the RAM monitor - which
 * services all future requests.
 * .KB_C_FN_DEFINITION_END
 */
int
main(void)
{
	printf("\r\nEntry: RAM Monitor v1.3.0\r\n");

	InitPrompt();

	InitProcessor();

	InitEEPROM();

	InitFlash();

	InitTWSI();

	InitIrDA();

	EMAC_Init();

	InitUHP();

	SPI_InitFlash();

	Init_Xmodem();

	InitLCD();

	InitLED();

	RAM_Monitor(0);

	return (1);
}
