/*-
 * Copyright (c) 2006 M. Warner Losh <imp@village.org> 
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $FreeBSD$
 */
#ifndef DEV_SDHC_SDHCVAR_H
#define DEV_SDHC_SDHCVAR_H

#define SDHC_MAX_RES 6

struct sdhc_softc 
{
	int flags;
#define SDHC_FLAG_HASDMA	1
	int nres;
	struct resource *res[SDHC_MAX_RES];
	struct resource *irq_res;
	void *intrhand;
};

struct sdhc_ivars
{
	struct resource *res;
};

int sdhc_attach(device_t dev);
int sdhc_detach(device_t dev);
int sdhc_read_ivar(device_t dev, device_t child, int which, uintptr_t *result);
int sdhc_write_ivar(device_t dev, device_t child, int which, uintptr_t value);
struct resource *
sdhc_alloc_resource(device_t dev, device_t child, int type, int *rid,
    u_long start, u_long end, u_long count, u_int flags);
int sdhc_release_resource(device_t dev, device_t child, int type, int rid,
    struct resource *r);
void sdhc_child_detached(device_t dev, device_t child);

extern devclass_t sdhc_devclass;

enum sdhc_device_ivars {
    SDHC_IVAR_RESOURCE
};

/*
 * Simplified accessors for pci devices
 */
#define SDHC_ACCESSOR(var, ivar, type)					\
	__BUS_ACCESSOR(sdhc, var, SDHC, ivar, type)

SDHC_ACCESSOR(resource,		RESOURCE,	struct resource *)

#undef SDHC_ACCESSOR

#endif /* ! DEV_SDHC_SDHCVAR_H */
